import java.util.*;

public class Ex_Btree {
	
/**
 * Esercizio 1  II parziale 10.01.2018
 * Un albero binario di interi si dice pari se tutti i nodi contengono
 * un intero positivo pari.  Realizzare il metodo statico 
 * public static boolean IsEvenBtree (BinaryTree<Integer> btree) 
 * che verifica se lalbero binario dato btree  pari.
 **/

 /* soluzione ricorsiva */

 public static boolean IsEvenBtree (BinaryTree<Integer> btree) {
	 if (btree.isEmpty()) return true;
	 return IsEvenBtree(btree.getRoot());
 }
 
 public static boolean IsEvenBtree (BinaryNode<Integer> node) {
	 int s = node.getData();
	 if (s % 2 == 1) return false;
	 else return IsEvenBtree (node.getLeft()) && IsEvenBtree (node.getRight());
 }
 
 /* soluzione iterativa */
 
 public static boolean IsEvenBtreeIt (BinaryTree<Integer> btree) {
	boolean isEven = true;		
	if (btree.isEmpty()) return true; 
	Iterator<Integer> itr = btree.iteratorLevelOrder();		
	while (itr.hasNext() && isEven) {
		if (itr.next() % 2 == 1) isEven = false;	
	}
	return isEven;
} 
 
 
 /**
  * EX1 - II parziale 8/1/2019
  * Scrivere un metodo generico statico ContaDuplicati che conta il
  * numero di oggetti duplicati (non univoci) contenuti in un albero binario.
  * Porre particolare attenzione alla scelta della firma.
  * 
  */
 
public static <E> int ContaDuplicati(BinaryTree<E> t) {
	HashMap<E, Integer> occmap = new HashMap<E, Integer>();
	Iterator<E> itr = t.iteratorInOrder();
	int value, count = 0;
	E key;
	while (itr.hasNext()) {
		key = itr.next();
		if (occmap.containsKey(key))
			value = occmap.get(key) + 1;
		else value = 1;
		occmap.put(key, value);
	}
	for (Map.Entry<E, Integer> entry: occmap.entrySet()) {
		if (entry.getValue() > 1) count++;
	}
	return count;
}
	
	
	
public static <E> int ContaDuplicati2(BinaryTree<E> t) {
	HashMap<E, Integer> occmap = new HashMap<E, Integer>();
	Iterator<E> itr = t.iteratorInOrder();
	int count = 0;
	// inizializza la mappa
	while (itr.hasNext()) occmap.put(itr.next(), 0);
	itr = t.iteratorInOrder();
	// aggiorna le occorrenze
	while (itr.hasNext()) {
		E key = itr.next();
		occmap.put(key, occmap.get(key) + 1);
	}
	for (Map.Entry<E, Integer> entry: occmap.entrySet()) {
		if (entry.getValue() > 1) count++;
	}
	return count;
}

 
 
 /****************************************************************************
 Realizzare il metodo statico
 public static Integer MaxValue(BinaryTree<Integer> btree) 
 che restituisce il riferimento all'intero pi grande contenuto in btree
 *****************************************************************************/


public static Integer MaxValue(BinaryTree<Integer> btree) {
	Integer current, max;		

	if (btree.isEmpty()) return null; 
	Iterator<Integer> itr = btree.iteratorLevelOrder();		
	max = itr.next();
	while (itr.hasNext()) {
		current = itr.next();
		if (max.compareTo(current) < 0) max = current;	
	}
 		return max;
}  // method MaxValue



/*** EX2 I appello 2015/2016  del 27/01/2016  
Un albero binario si dice pieno se tutti i nodi hanno esattamente 0 o 2 figli,
e nessun nodo ha 1 figlio. 
Si aggiunga alla classe BinaryNode<E> un metodo ricorsivo
public boolean isFullBtree()  
che verifica se l'albero binario radicato nel nodo corrente e' pieno. 	
 
	public boolean isFullBtree() {
		if (this == null || (left == null && right == null) ) return true; 
		if ( left !=null && right != null) return (left.isFullBtree() && right.isFullBtree());
		else return false;
	}  // method isFullBtree
	
*/

/****************************************************************************
Si aggiunga alla classe BinaryNode<E> un metodo ricorsivo  
public BinaryNode<E> mirror()
che dato il nodo corrente restituisce il suo nodo "specchio", ovvero
il nuovo nodo deve essere radice di un albero binario che 
immagine speculare dell'albero binario radicato nel nodo corrente: 
ogni figlio destro di questo sottoalbero diventa sinistro e viceversa.

  	    public BinaryNode<E> mirror() {
   	    	BinaryNode<E> l = null, r = null;
   	    	if (right != null) r = right.mirror();
  	    	if (left  != null) l = left.mirror();
   	 		return new BinaryNode<E>(r, data, l);
   	 	}  // mirror
*/
	 
}

